package com.tashow.cloud.product.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tashow.cloud.productapi.api.product.dto.ProdPropDO;
import com.tashow.cloud.productapi.api.product.dto.ProdPropValueDO;
import com.tashow.cloud.product.mapper.ProdPropMapper;
import com.tashow.cloud.product.mapper.ProdPropValueMapper;
import com.tashow.cloud.product.service.ProdPropValueService;
import com.tashow.cloud.productapi.api.product.vo.prodpropvalue.ProdPropValuePageReqVO;
import com.tashow.cloud.productapi.api.product.vo.prodpropvalue.ProdPropValueSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;
import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;
import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 属性规则 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProdPropValueServiceImpl  extends ServiceImpl<ProdPropValueMapper, ProdPropValueDO> implements ProdPropValueService {

    @Resource
    private ProdPropValueMapper prodPropValueMapper;

    @Override
    public Long createProdPropValue(ProdPropValueSaveReqVO createReqVO) {
        // 插入
        ProdPropValueDO prodPropValue = BeanUtils.toBean(createReqVO, ProdPropValueDO.class);
        prodPropValueMapper.insert(prodPropValue);
        // 返回
        return prodPropValue.getPropId();
    }

    @Override
    public void updateProdPropValue(ProdPropValueSaveReqVO updateReqVO) {
        // 校验存在
        validateProdPropValueExists(updateReqVO.getPropId());
        // 更新
        ProdPropValueDO updateObj = BeanUtils.toBean(updateReqVO, ProdPropValueDO.class);
        prodPropValueMapper.updateById(updateObj);
    }

    @Override
    public void deleteProdPropValue(Long id) {
        // 校验存在
        validateProdPropValueExists(id);
        // 删除
        prodPropValueMapper.deleteProdPropValueById(id);
    }

    private void validateProdPropValueExists(Long id) {
        if (prodPropValueMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PROD_PROP_VALUE_NOT_EXISTS);
        }
    }

    @Override
    public ProdPropValueDO getProdPropValue(Long id) {
        return prodPropValueMapper.selectById(id);
    }

    @Override
    public PageResult<ProdPropValueDO> getProdPropValuePage(ProdPropValuePageReqVO pageReqVO) {
        return null;
    }

}